/*******************************************************************************
Copyright (c) 2012, Jonathan Hiller

This file is part of the AMF Tools suite. http://amf.wikispaces.com/
AMF Tools is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
AMF Tools is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.
See <http://www.opensource.org/licenses/lgpl-3.0.html> for license details.
*******************************************************************************/

#ifndef SIMPLEIMAGE_H
#define SIMPLEIMAGE_H

#include <string>

//enum IndexMode {IM_VBW};


class CSimpleImage
{
public:
	CSimpleImage(void);
	~CSimpleImage(void);
	CSimpleImage(const CSimpleImage& In) {*this = In;}
	CSimpleImage& operator=(const CSimpleImage& In);

	bool LoadImage(std::string FilePath);
	bool IsBw(void) const {return DataBw;}
	void ToBw(void);
	void ToRgba(void);

	int Width(void)  {return DataWidth;}
	int Height(void) {return DataHeight;}

	bool AllocateRgba(int WidthIn, int HeightIn);
	bool AllocateBw(int WidthIn, int HeightIn);
//	bool IndexFromRGBA(IndexMode IndexModeIn);

//	bool IndexExists() {if (pDataIndex) return true; else return false;}
	bool HasAlphaChannel() {return AlphaPresent;}
//	unsigned char* GetRGBABits(void) {if (!DataBw) return pData; else return NULL;}
//	unsigned char* GetBwBits(void) {if (DataBw) return pData; else return NULL;}
	unsigned char* GetBits(void) {return pData;}

	int GetBpp(void){return DataBw?2:4;}
	int GetAlphaOffset(void){return DataBw?1:3;} 
//	int* GetIndexBits(void) {return pDataIndex;}

	void FillRgba(unsigned char R, unsigned char G, unsigned char B, unsigned char A = 255);
	void FillBw(unsigned char Grey, unsigned char A = 255);

private:
//	IndexMode CurIndexMode;
	bool AlphaPresent;
	bool DataBw; //is this a 2bpp b+w/a image or 4bpp rgba image?

	unsigned char* pData;
	int DataWidth, DataHeight;
//	int* pDataIndex;
//	int PixelDataIndexWidth, PixelDataIndexHeight;


};

#endif //SIMPLEIMAGE_H
